/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef P_1_H
#define P_1_H

#include "math.h"
#include "yapi.h"

#include "aux_func.h"
#include <iostream>


class P_1 : public Process {
  private:

    // Input Gates and controllers

    // Output Gates
    OutPort<tCH_1> OG_1;
    OutPort<tCH_2> OG_2;
    OutPort<tCH_3> OG_3;
    OutPort<tCH_4> OG_4;
    OutPort<tCH_5> OG_5;
    OutPort<tCH_6> OG_6;
    OutPort<tCH_7> OG_7;
    OutPort<tCH_8> OG_8;
    OutPort<tCH_9> OG_9;
    OutPort<tCH_10> OG_10;
    OutPort<tCH_11> OG_11;
    OutPort<tCH_12> OG_12;

    // Parameters
    int N;
    int M;

    // Input Arguments 

    // Output Arguments 
    tCH_12 out_0ND_0;

  public:

    // Constructor 
    P_1(Id n,
    Out<tCH_1>& OG_1_instance,
    Out<tCH_2>& OG_2_instance,
    Out<tCH_3>& OG_3_instance,
    Out<tCH_4>& OG_4_instance,
    Out<tCH_5>& OG_5_instance,
    Out<tCH_6>& OG_6_instance,
    Out<tCH_7>& OG_7_instance,
    Out<tCH_8>& OG_8_instance,
    Out<tCH_9>& OG_9_instance,
    Out<tCH_10>& OG_10_instance,
    Out<tCH_11>& OG_11_instance,
    Out<tCH_12>& OG_12_instance,
    int parm_N,
    int parm_M) :
    Process(n),
    OG_1(id("OG_1"), OG_1_instance ),
    OG_2(id("OG_2"), OG_2_instance ),
    OG_3(id("OG_3"), OG_3_instance ),
    OG_4(id("OG_4"), OG_4_instance ),
    OG_5(id("OG_5"), OG_5_instance ),
    OG_6(id("OG_6"), OG_6_instance ),
    OG_7(id("OG_7"), OG_7_instance ),
    OG_8(id("OG_8"), OG_8_instance ),
    OG_9(id("OG_9"), OG_9_instance ),
    OG_10(id("OG_10"), OG_10_instance ),
    OG_11(id("OG_11"), OG_11_instance ),
    OG_12(id("OG_12"), OG_12_instance ),
    N(parm_N),
    M(parm_M)
    {
    }; 

    const char* type() const {return "P_1";};

    void main() {

      for( int c0 =  ceil1(1); c0 <=  floor1(M ); c0 += 1 ) {
        for( int c1 =  ceil1(1); c1 <=  floor1(N ); c1 += 1 ) {

            _readPixel(out_0ND_0) ;
            execute("_readPixel");

            if( -c0 + M-2 >= 0 ) {
              if( -c1 + N-2 >= 0 ) {

                write( OG_1, out_0ND_0);

              }
            }
            if( c0-2 >= 0 ) {
              if( -c0 + M-1 >= 0 ) {
                if( -c1 + N-2 >= 0 ) {

                  write( OG_2, out_0ND_0);

                }
              }
            }
            if( c0-3 >= 0 ) {
              if( -c1 + N-2 >= 0 ) {

                write( OG_3, out_0ND_0);

              }
            }
            if( -c0 + M-2 >= 0 ) {
              if( c1-3 >= 0 ) {

                write( OG_4, out_0ND_0);

              }
            }
            if( c0-2 >= 0 ) {
              if( -c0 + M-1 >= 0 ) {
                if( c1-3 >= 0 ) {

                  write( OG_5, out_0ND_0);

                }
              }
            }
            if( c0-3 >= 0 ) {
              if( c1-3 >= 0 ) {

                write( OG_6, out_0ND_0);

              }
            }
            if( -c0 + M-2 >= 0 ) {
              if( -c1 + N-2 >= 0 ) {

                write( OG_7, out_0ND_0);

              }
            }
            if( -c0 + M-2 >= 0 ) {
              if( c1-2 >= 0 ) {
                if( -c1 + N-1 >= 0 ) {

                  write( OG_8, out_0ND_0);

                }
              }
            }
            if( -c0 + M-2 >= 0 ) {
              if( c1-3 >= 0 ) {

                write( OG_9, out_0ND_0);

              }
            }
            if( c0-3 >= 0 ) {
              if( -c1 + N-2 >= 0 ) {

                write( OG_10, out_0ND_0);

              }
            }
            if( c0-3 >= 0 ) {
              if( c1-2 >= 0 ) {
                if( -c1 + N-1 >= 0 ) {

                  write( OG_11, out_0ND_0);

                }
              }
            }
            if( c0-3 >= 0 ) {
              if( c1-3 >= 0 ) {

                write( OG_12, out_0ND_0);

              }
            }
        } // for c1
      } // for c0

    } // main
};

#endif
