/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef P_5_H
#define P_5_H

#include "math.h"
#include "yapi.h"

#include "aux_func.h"
#include <iostream>


class P_5 : public Process {
  private:

    // Input Gates and controllers
    InPort<tCH_15> IG_1;

    // Output Gates

    // Parameters
    int N;
    int M;

    // Input Arguments 
    tCH_15 in_0ND_4;

    // Output Arguments 

  public:

    // Constructor 
    P_5(Id n,
    In<tCH_15>& IG_1_instance,
    int parm_N,
    int parm_M) :
    Process(n),
    IG_1(id("IG_1"), IG_1_instance ),
    N(parm_N),
    M(parm_M)
    {
    }; 

    const char* type() const {return "P_5";};

    void main() {

      for( int c0 =  ceil1(3); c0 <=  floor1(M ); c0 += 1 ) {
        for( int c1 =  ceil1(3); c1 <=  floor1(N ); c1 += 1 ) {
            read(IG_1, in_0ND_4);


            _writePixel(in_0ND_4) ;
            execute("_writePixel");

        } // for c1
      } // for c0

    } // main
};

#endif
