/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef aux_func_H
#define aux_func_H

#include <math.h>
#include "sobel_func.h"

typedef int tCH_1;
typedef int tCH_2;
typedef int tCH_3;
typedef int tCH_4;
typedef int tCH_5;
typedef int tCH_6;
typedef int tCH_7;
typedef int tCH_8;
typedef int tCH_9;
typedef int tCH_10;
typedef int tCH_11;
typedef int tCH_12;
typedef int tCH_13;
typedef int tCH_14;
typedef int tCH_15;

inline
void  _readPixel( tCH_12 &out_0 ) {
    readPixel( &out_0 );
}

inline
void  _gradient( tCH_1 in_0, tCH_2 in_1, tCH_3 in_2, tCH_4 in_3, tCH_5 in_4, tCH_6 in_5, tCH_13 &out_6 ) {
    gradient( &in_0, &in_1, &in_2, &in_3, &in_4, &in_5, &out_6 );
}

inline
void  _absVal( tCH_13 in_0, tCH_14 in_1, tCH_15 &out_2 ) {
    absVal( &in_0, &in_1, &out_2 );
}

inline
void  _writePixel( tCH_15 in_0 ) {
    writePixel( &in_0 );
}


inline
double min( double a, double b ){
  if ( a>=b )  {
    return b;
  } else {
    return a;
  }
}

inline
double max( double a, double b ){
  if ( a>=b )  {
    return a;
  } else {
    return b;
  }
}

inline
int ddiv( double a, double b ){

    //return (int)(a/b);
    return ( (int) (((a)<0) ? ((a)-(b)+1)/(b) : (a)/(b)) ); 
    //return ( (int) (((a)<0)^((b)<0) ? ((a) < 0 ? ((a)-(b)+1)/(b) : ((a)-(b)-1)/(b)) : (a)/(b)) ); 
}

inline
int mod( double a, double b ){

    return (int)fmod(a, b);
}

inline
int ceil1( double a ){

    return (int) ceil(a);
}

inline
int floor1( double a ){

    return (int) floor(a);
}


#endif
