/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#include <stdlib.h>
#include "imageIO.h"
//#include "MemoryMap.h"
#include "sobel_func.h"

void gradient( const int *a1, const int *a2, const int *a3, const int *a4, const int *a5, const int *a6, int *output ){

    *output = ( ((*a4)+((*a5)<<1)+(*a6)) - ((*a1)+((*a2)<<1)+(*a3)) );

}


void absVal( const int *x, const int *y, int *output ) {

    *output = ( (abs(*x)+abs(*y))/4 );

}


void readPixel( int *output ) {
//*
        int pp;
	static FILE *fh = NULL;

	if (fh == NULL) {
           fh = mrOpen("car_gray.B");
	}

	pp = mGetc(fh);
	*output =  pp;
/*/
        static int addr = 0;
        *output = *(ZBT_MEM+(addr++));
//*/
}

void  writePixel( const int *pp ) {
//*
	static FILE *fh = NULL;

	if (fh == NULL) {
           fh = mwOpen("car_gray_sobel.raw");
	}

	mPutc(fh, *pp);
/*/
        static int addr = 0;
        *(ZBT_MEM+(addr++)) = *pp;
//*/
}
