/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#include "sobel_func.h"

int N = 450;
#pragma parameter N 450 1000
int M = 275;
#pragma parameter M 275 1000

int main(void)
{
   int i, j;

   static int image[1000][1000];
   static int Jx[1000][1000];
   static int Jy[1000][1000];
   static int av[1000][1000];
   

   for (j=1; j <= M; j++) {
      for (i=1; i <= N; i++) {
         readPixel(&image[j][i]);
      }
   }

   for (j=2; j <= M-1; j++) {
      for (i=2; i <= N-1; i++) {
           gradient( &image[j-1][i-1], &image[j][i-1], &image[j+1][i-1], &image[j-1][i+1], &image[j][i+1], &image[j+1][i+1], &Jx[j][i] );
      }
   }

   for (j=2; j <= M-1; j++) {
      for (i=2; i <= N-1; i++) {
          gradient( &image[j-1][i-1], &image[j-1][i], &image[j-1][i+1], &image[j+1][i-1], &image[j+1][i], &image[j+1][i+1], &Jy[j][i] );
      }
   }

   for (j=2; j <= M-1; j++) {
      for (i=2; i <= N-1; i++) {
           absVal( &Jx[j][i], &Jy[j][i], &av[j][i] );
      }
   }

   for (j=2; j <= M-1; j++) {
      for (i=2; i <= N-1; i++) {
          writePixel( &av[j][i] );
      }
   }

   return (0);
}

